Subject: Re: How can Zle -U interfere with zsh-syntax-highlighting?
From: Daniel Shahaf <[email-masked]>
To: Zsh hackers list <[email-masked]>
Date: Thu, 19 May 2016 21:22:18 +0000
List-Id: Zsh Workers List <zsh-workers.zsh.org>

Bart Schaefer wrote on Sun, May 15, 2016 at 04:13:21 -0700:
> I suppose it might make sense for "zle -U" to pretend to be actual
> input even to the extent of PENDING, but it currently does not.

Like this?

[[[
diff --git a/Src/Zle/zle_params.c b/Src/Zle/zle_params.c
index c6387bf..d5b1e87 100644
--- a/Src/Zle/zle_params.c
+++ b/Src/Zle/zle_params.c
@@ -500,7 +500,7 @@ get_bufferlines(UNUSED(Param pm))
 static zlong
 get_pending(UNUSED(Param pm))
 {
-    return noquery(0);
+    return noquery(0) + kungetct;
 }
 
 /**/
]]]

It doesn't cause any obvious problem, but I couldn't reproduce the
original slowdown so I'm not sure whether this patch fixes it.

In any case, I won't push it yet since I won't be able to commit
followups timely in case it breaks something — but if someone else wants
to push it before I get back, feel free.

Cheers,

Daniel